image: docker:latest

services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay
  REGISTRY_BASE: registry.gitlab.com/chvote2/infra/docker-node-karma-protractor-chrome
  IMAGE_NAME: docker-node-karma-protractor-chrome
  TAG_STAGING: staging-$CI_COMMIT_REF_NAME
  TAG: $CI_COMMIT_REF_NAME

stages:
  - build
  - deploy

before_script:
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com

build-image:
  stage: build
  script:
    - docker build -t $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING .
    - docker push $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING

deploy-tag-staging-to-registry:
  stage: deploy
  script:
    - docker pull $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING
    - docker tag $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING $REGISTRY_BASE/$IMAGE_NAME:$TAG
    - docker push $REGISTRY_BASE/$IMAGE_NAME:$TAG

deploy-latest-to-registry:
  stage: deploy
  script:
    - docker pull $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING
    - docker tag $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING $REGISTRY_BASE/$IMAGE_NAME:latest
    - docker push $REGISTRY_BASE/$IMAGE_NAME:latest
